require "#{File.dirname(File.expand_path(__FILE__))}/test_helper"
class PointTest < MiniTest::Unit::TestCase
  def test_initalizer
    point = Point.new(2,Polynomial.new(7).calculate(2))
    assert_equal 2, point.x
    assert_equal 7, point.y
  end

  def test_to_s
    point = Point.new(1,Polynomial.new(1).calculate(1))
    assert_equal "(1,1.0)", point.to_s
  end

  def test_equality
    point1 = Extremum.new(5,Polynomial.new(0.0).calculate(0), :maximum)
    point2 = Extremum.new(5,Polynomial.new(0).calculate(0), :maximum)
    point3 = Point.new(5,Polynomial.new(0).calculate(0))
    assert point1.eql?(point2)
    refute point3.eql?(point2)
  end

  def test_comparison
    point1 = Point.new(1,Polynomial.new(5).calculate(1))
    point2 = Point.new(3,Polynomial.new(5).calculate(3))
    point3 = Point.new(0.5,Polynomial.new(5).calculate(0.5))
    point4 = Point.new(0.5,Polynomial.new(5).calculate(0.5))
    assert point1 < point2
    assert point1 > point3
    assert point4 <= point3
    assert point4 <= point2
  end

  def test_root
    assert_equal '(50,0)', Root.new(50).to_s
  end

  def test_boolean_max_min_meths
    assert_equal true,Extremum.new(2,3,:maximum).maximum?
    assert_equal true,Extremum.new(2,3,:minimum).minimum?
    assert_equal false,Extremum.new(2,3,:maximum).minimum?
    assert_equal false, Root.new(2).minimum?
  end

	def test_bolean_check_methods
		assert_equal true, InflectionPoint.new(2,3).inflection_point?
		assert_equal true, Extremum.new(2,3, :maximum).extremum?
		assert_equal true, Root.new(2).root?
		assert_equal false, Root.new(3).extremum?
	end
end

